package nettytest;

import java.net.InetSocketAddress;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

import org.jboss.netty.bootstrap.ClientBootstrap;
import org.jboss.netty.bootstrap.ServerBootstrap;
import org.jboss.netty.buffer.ChannelBuffer;
import org.jboss.netty.buffer.ChannelBuffers;
import org.jboss.netty.channel.Channel;
import org.jboss.netty.channel.ChannelFactory;
import org.jboss.netty.channel.ChannelFuture;
import org.jboss.netty.channel.ChannelPipeline;
import org.jboss.netty.channel.socket.nio.NioClientSocketChannelFactory;
import org.jboss.netty.channel.socket.nio.NioServerSocketChannelFactory;
import org.jboss.netty.handler.timeout.HashedWheelTimer;
import org.jboss.netty.handler.timeout.ReadTimeoutHandler;
import org.jboss.netty.handler.timeout.Timer;
import org.jboss.netty.handler.timeout.WriteTimeoutHandler;

public class NettyTestClient {

    final static String host = "localhost";
    final static int port = 12345;

    public static void main(String[] args) {
	ChannelFactory factory = new NioClientSocketChannelFactory(Executors.newCachedThreadPool(), Executors
		.newCachedThreadPool());
	ClientBootstrap bootstrap = new ClientBootstrap(factory);
	ChannelPipeline pipeline = bootstrap.getPipeline();

	pipeline.addLast("handler", new TestHandler());

	bootstrap.setOption("tcpNoDelay", true);
	bootstrap.setOption("keepAlive", true);
	ChannelFuture f = bootstrap.connect(new InetSocketAddress(host, port));
	f.awaitUninterruptibly();
	Channel ch = f.getChannel();
	if (ch.isConnected())
	    System.out.println("channel connected");
	else
	    System.out.println("channel NOT connected");
	ChannelBuffer time = ChannelBuffers.buffer(10);
	time.writeLong(System.currentTimeMillis());
	ch.write(time).awaitUninterruptibly();
	System.out.println("message sent");
    }

}
